



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mapreduce实现&quot;浏览该商品的人大多数还浏览了&quot;经典应用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mapreduce实现&quot;浏览该商品的人大多数还浏览了&quot;经典应用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 23:08:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>输入:</strong></p>
<p>日期&nbsp;&nbsp;&nbsp; ...cookie id.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ...商品id..</p>
<p>xx&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; xx&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; xx</p>
<p><strong>输出:</strong></p>
<p>商品id&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;商品id列表(按优先级排序,用逗号分隔)</p>
<p>xx&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; xx</p>
<p>比如:</p>
<p>id1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; id3,id0,id4,id2</p>
<p>id2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; id0,id5</p>
<p><strong>整个计算过程分为4步</strong></p>
<p>1、提取原始日志日期,cookie id,商品id信息，按天计算,最后输出数据格式</p>
<p>商品id-0 商品id-1</p>
<p>xx&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; x x</p>
<p>这一步做了次优化,商品id-0一定比商品id-1小，为了减少存储，在最后汇总数据转置下即可</p>
<p>reduce做局部排序及排重</p>
<p>2、基于上次的结果做汇总,按天计算</p>
<p>商品id-0 商品id-1&nbsp; 关联值(关联值即同时访问这两个商品的用户数)</p>
<p>xx&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; &nbsp;x x&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; xx</p>
<p>3、汇总最近三个月数据,同时考虑时间衰减,时间越久关联值的贡献越低,最后输出两两商品的关联值（包括转置后)</p>
<p>4、行列转换，生成最后要的推荐结果数据,按关联值排序生成</p>
<p><strong>第一个MR</strong></p>
<div>
<pre class="prettyprint linenums"> &lt;strong&gt;import java.io.IOException;
 import java.util.ArrayList;
 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.LongWritable;
 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;
 import org.apache.hadoop.io.WritableComparator;
 import org.apache.hadoop.mapreduce.Job;
 import org.apache.hadoop.mapreduce.Mapper;
 import org.apache.hadoop.mapreduce.Partitioner;
 import org.apache.hadoop.mapreduce.Reducer;
 import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
 import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
 import org.apache.hadoop.util.GenericOptionsParser;
 import org.apache.log4j.Logger;

 /*
  * 输入:原始数据,会有重复
  *日期 cookie 楼盘id
  *
  * 输出:
  * 日期 楼盘id1 楼盘id2  //楼盘id1一定小于楼盘id2 ,按日期 cookie进行分组
  *
  */

 public class HouseMergeAndSplit {

     public static class Partitioner1 extends Partitioner&lt;TextPair, Text&gt; {
           @Override
           public int getPartition(TextPair key, Text value, int numParititon) {
                       return Math.abs((new Text(key.getFirst().toString()+key.getSecond().toString())).hashCode() * 127) % numParititon;

           }
     }
           public static class Comp1 extends WritableComparator {
               public Comp1() {
                super(TextPair.class, true);
               }
               @SuppressWarnings("unchecked")
               public int compare(WritableComparable a, WritableComparable b) {
                TextPair t1 = (TextPair) a;
                TextPair t2 = (TextPair) b;
                int comp= t1.getFirst().compareTo(t2.getFirst());
                if (comp!=0)
                    return comp;
                return t1.getSecond().compareTo(t2.getSecond());
               }
             }
       public static class TokenizerMapper
            extends Mapper&lt;LongWritable, Text, TextPair, Text&gt;{
                   Text val=new Text("test");
         public void map(LongWritable key, Text value, Context context
                         ) throws IOException, InterruptedException {
                        &amp;nbsp; String s[]=value.toString().split("\001");
                 TextPair tp=new TextPair(s[0],s[1],s[4]+s[3]); //thedate cookie city+houseid
                context.write(tp, val);
         }
       }

       public static class IntSumReducer
            extends Reducer&lt;TextPair,Text,Text,Text&gt; {
           private static String comparedColumn[] = new String[3];
           ArrayList&lt;String&gt; houselist= new ArrayList&lt;String&gt;();
           private static Text keyv = new Text();

           private static Text valuev = new Text();
           static Logger logger = Logger.getLogger(HouseMergeAndSplit.class.getName());

         public void reduce(TextPair key, Iterable&lt;Text&gt; values,
                            Context context
                            ) throws IOException, InterruptedException {

             houselist.clear();
             String thedate=key.getFirst().toString();
             String cookie=key.getSecond().toString();  

             for (int i=0;i&lt;3;i++)
                 comparedColumn[i]="";

             //first+second为分组键,每次不同重新调用reduce函数
             for (Text val:values)
             {

                 if (thedate.equals(comparedColumn[0]) &amp;&amp; cookie.equals(comparedColumn[1])&amp;&amp;  !key.getThree().toString().equals(comparedColumn[2]))
                  {
                     // context.write(new Text(key.getFirst()+" "+key.getSecond().toString()), new Text(key.getThree().toString()+" first"+ " "+comparedColumn[0]+" "+comparedColumn[1]+" "+comparedColumn[2]));
                      houselist.add(key.getThree().toString());

                      comparedColumn[0]=key.getFirst().toString();
                        comparedColumn[1]=key.getSecond().toString();
                        comparedColumn[2]=key.getThree().toString();

                  }

                    if (!thedate.equals(comparedColumn[0])||!cookie.equals(comparedColumn[1]))

                        {

                      //  context.write(new Text(key.getFirst()+" "+key.getSecond().toString()), new Text(key.getThree().toString()+" second"+ " "+comparedColumn[0]+" "+comparedColumn[1]+" "+comparedColumn[2]));
                        houselist.add(key.getThree().toString());
                        comparedColumn[0]=key.getFirst().toString();
                        comparedColumn[1]=key.getSecond().toString();
                        comparedColumn[2]=key.getThree().toString();

                        }

             }

             keyv.set(comparedColumn[0]); //日期
             //valuev.set(houselist.toString());
             //logger.info(houselist.toString());
             //context.write(keyv,valuev);

             for (int i=0;i&lt;houselist.size()-1;i++)
             {
                 for (int j=i+1;j&lt;houselist.size();j++)
                 {    valuev.set(houselist.get(i)+"    "+houselist.get(j)); //关联的楼盘
                     context.write(keyv,valuev);
                 }
             } 

         }
       }

       public static void main(String[] args) throws Exception {
         Configuration conf = new Configuration();
         String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
         if (otherArgs.length != 2) {
           System.err.println("Usage: wordcount &lt;in&gt; &lt;out&gt;");
           System.exit(2);
         }

         FileSystem fstm = FileSystem.get(conf);
         Path outDir = new Path(otherArgs[1]);
         fstm.delete(outDir, true);

    conf.set("mapred.textoutputformat.separator", "\t"); //reduce输出时key value中间的分隔符
         Job job = new Job(conf, "HouseMergeAndSplit");
         job.setNumReduceTasks(4);
         job.setJarByClass(HouseMergeAndSplit.class);
         job.setMapperClass(TokenizerMapper.class);

         job.setMapOutputKeyClass(TextPair.class);
         job.setMapOutputValueClass(Text.class);
         // 设置partition
         job.setPartitionerClass(Partitioner1.class);
         // 在分区之后按照指定的条件分组
         job.setGroupingComparatorClass(Comp1.class);
         // 设置reduce
         // 设置reduce的输出
         job.setReducerClass(IntSumReducer.class);
         job.setOutputKeyClass(Text.class);
         job.setOutputValueClass(Text.class);
         //job.setNumReduceTasks(18);
         FileInputFormat.addInputPath(job, new Path(otherArgs[0]));
         FileOutputFormat.setOutputPath(job, new Path(otherArgs[1]));
         System.exit(job.waitForCompletion(true) ? 0 : 1);
       }
 }&lt;/strong&gt;</pre>
</div>
<p>TextPair</p>
<div>
<pre class="prettyprint linenums"> import java.io.DataInput;
 import java.io.DataOutput;
 import java.io.IOException;

 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;

 public class TextPair implements WritableComparable&lt;TextPair&gt; {
     private Text first;
     private Text second;
     private Text three;
     public TextPair() {
       set(new Text(), new Text(),new Text());
     }
     public TextPair(String first, String second,String three) {
       set(new Text(first), new Text(second),new Text(three));
     }
     public TextPair(Text first, Text second,Text Three) {
       set(first, second,three);
     }
     public void set(Text first, Text second,Text three) {
       this.first = first;
       this.second = second;
       this.three=three;
     }
     public Text getFirst() {
       return first;
     }
     public Text getSecond() {
       return second;
     }
     public Text getThree() {
           return three;
         }
     public void write(DataOutput out) throws IOException {
       first.write(out);
       second.write(out);
       three.write(out);
     }
     public void readFields(DataInput in) throws IOException {
       first.readFields(in);
       second.readFields(in);
       three.readFields(in);
     }
     public int compareTo(TextPair tp) {
       int cmp = first.compareTo(tp.first);
       if (cmp != 0) {
        return cmp;
       }
       cmp= second.compareTo(tp.second);
       if (cmp != 0) {
            return cmp;
           }
       return three.compareTo(tp.three);
     }
     }</pre>
</div>
<p>TextPairSecond</p>
<div>
<pre class="prettyprint linenums"> import java.io.DataInput;
 import java.io.DataOutput;
 import java.io.IOException;

 import org.apache.hadoop.io.FloatWritable;
 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;

 public class TextPairSecond implements WritableComparable&lt;TextPairSecond&gt; {
     private Text first;
     private FloatWritable second;
     public TextPairSecond() {
       set(new Text(), new FloatWritable());
     }
     public TextPairSecond(String first, float second) {
       set(new Text(first), new FloatWritable(second));
     }
     public TextPairSecond(Text first, FloatWritable second) {
       set(first, second);
     }
     public void set(Text first, FloatWritable second) {
       this.first = first;
       this.second = second;
     }
     public Text getFirst() {
       return first;
     }
     public FloatWritable getSecond() {
       return second;
     }
     public void write(DataOutput out) throws IOException {
       first.write(out);
       second.write(out);
     }
     public void readFields(DataInput in) throws IOException {
       first.readFields(in);
       second.readFields(in);
     }
     public int compareTo(TextPairSecond tp) {
       int cmp = first.compareTo(tp.first);
       if (cmp != 0) {
        return cmp;
       }
       return second.compareTo(tp.second);
     }

     }</pre>
</div>
<p><strong>第二个MR</strong></p>
<div>
<pre class="prettyprint linenums"> &lt;strong&gt;import java.io.IOException;
 import java.text.SimpleDateFormat;
 import java.util.ArrayList;
 import java.util.Date;

 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.IntWritable;
 import org.apache.hadoop.io.LongWritable;
 import org.apache.hadoop.io.NullWritable;
 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;
 import org.apache.hadoop.io.WritableComparator;
 import org.apache.hadoop.mapred.OutputCollector;
 import org.apache.hadoop.mapreduce.Job;
 import org.apache.hadoop.mapreduce.Mapper;
 import org.apache.hadoop.mapreduce.Partitioner;
 import org.apache.hadoop.mapreduce.Reducer;

 import org.apache.hadoop.mapreduce.Mapper.Context;
 import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
 import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
 import org.apache.hadoop.util.GenericOptionsParser;
 import org.apache.log4j.Logger;

 /*
  *  统计楼盘之间共同出现的次数
  * 输入:
  * 日期 楼盘1 楼盘2
  *
  * 输出：
  * 日期 楼盘1 楼盘2 共同出现的次数
  *
  */

 public class HouseCount {

       public static class TokenizerMapper
            extends Mapper&lt;LongWritable, Text, Text, IntWritable&gt;{

     IntWritable iw=new IntWritable(1);
         public void map(LongWritable key, Text value, Context context
                         ) throws IOException, InterruptedException {

          context.write(value, iw);
         }
       }

       public static class IntSumReducer
            extends Reducer&lt;Text,IntWritable,Text,IntWritable&gt; {

          IntWritable result=new IntWritable();
         public void reduce(Text key, Iterable&lt;IntWritable&gt; values,
                            Context context
                            ) throws IOException, InterruptedException {

              int sum=0;
              for (IntWritable iw:values)
              {
                  sum+=iw.get();
              }
              result.set(sum);
          context.write(key, result)    ;

         }
       }

       public static void main(String[] args) throws Exception {
         Configuration conf = new Configuration();
         String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
         if (otherArgs.length != 2) {
           System.err.println("Usage: wordcount &lt;in&gt; &lt;out&gt;");
           System.exit(2);
         }

         FileSystem fstm = FileSystem.get(conf);
         Path outDir = new Path(otherArgs[1]);
         fstm.delete(outDir, true);

    conf.set("mapred.textoutputformat.separator", "\t"); //reduce输出时key value中间的分隔符
         Job job = new Job(conf, "HouseCount");
         job.setNumReduceTasks(2);
         job.setJarByClass(HouseCount.class);
         job.setMapperClass(TokenizerMapper.class);

         job.setMapOutputKeyClass(Text.class);
         job.setMapOutputValueClass(IntWritable.class);

         // 设置reduce
         // 设置reduce的输出
         job.setReducerClass(IntSumReducer.class);
         job.setOutputKeyClass(Text.class);
         job.setOutputValueClass(IntWritable.class);
         //job.setNumReduceTasks(18);
         FileInputFormat.addInputPath(job, new Path(otherArgs[0]));
         FileOutputFormat.setOutputPath(job, new Path(otherArgs[1]));
         System.exit(job.waitForCompletion(true) ? 0 : 1);
       }
 }&lt;/strong&gt;</pre>
</div>
<p><strong>第三个MR</strong></p>
<div>
<pre class="prettyprint linenums"> import java.io.IOException;
 import java.text.ParseException;
 import java.text.SimpleDateFormat;
 import java.util.ArrayList;
 import java.util.Calendar;
 import java.util.Date;

 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.FloatWritable;
 import org.apache.hadoop.io.IntWritable;
 import org.apache.hadoop.io.LongWritable;
 import org.apache.hadoop.io.NullWritable;
 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;
 import org.apache.hadoop.io.WritableComparator;
 import org.apache.hadoop.mapred.OutputCollector;
 import org.apache.hadoop.mapreduce.Job;
 import org.apache.hadoop.mapreduce.Mapper;
 import org.apache.hadoop.mapreduce.Partitioner;
 import org.apache.hadoop.mapreduce.Reducer;

 import org.apache.hadoop.mapreduce.Mapper.Context;
 import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
 import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
 import org.apache.hadoop.util.GenericOptionsParser;
 import org.apache.log4j.Logger;

 /*
  * 汇总近三个月统计楼盘之间共同出现的次数,考虑衰减系数， 并最后a b 转成 b a输出一次
  * 输入:
  * 日期  楼盘1 楼盘2 共同出现的次数
  *
  * 输出
  * 楼盘1 楼盘2 共同出现的次数（考虑了衰减系数，每天的衰减系数不一样)
  *
  */

 public class HouseCountHz {

       public static class HouseCountHzMapper
            extends Mapper&lt;LongWritable, Text, Text, FloatWritable&gt;{

     Text keyv=new Text();

     FloatWritable valuev=new FloatWritable();
         public void map(LongWritable key, Text value, Context context
                         ) throws IOException, InterruptedException {

         String[] s=value.toString().split("\t");
         keyv.set(s[1]+"    "+s[2]);//楼盘1,楼盘2
         Calendar date1=Calendar.getInstance();
           Calendar d2=Calendar.getInstance();

           Date b = null;
           SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
           try {
             b=sdf.parse(s[0]);
           } catch (ParseException e) {
            e.printStackTrace();
           }
           d2.setTime(b);
           long n=date1.getTimeInMillis();
           long birth=d2.getTimeInMillis();
           long sss=n-birth;
           int day=(int)((sss)/(3600*24*1000)); //该条记录的日期与当前日期的日期差
           float factor=1/(1+(float)(day-1)/10); //衰减系数
         valuev.set(Float.parseFloat(s[3])*factor);

          context.write(keyv, valuev);
         }
       }

       public static class HouseCountHzReducer
            extends Reducer&lt;Text,FloatWritable,Text,FloatWritable&gt; {

           FloatWritable result=new FloatWritable();
           Text keyreverse=new Text();
         public void reduce(Text key, Iterable&lt;FloatWritable&gt; values,
                            Context context
                            ) throws IOException, InterruptedException {

              float sum=0;
              for (FloatWritable iw:values)
              {
                  sum+=iw.get();
              }
              result.set(sum);
              String[] keys=key.toString().split("\t");
              keyreverse.set(keys[1]+"    "+keys[0]);
          context.write(key, result)    ;
          context.write(keyreverse, result)    ;

         }
       }

       public static void main(String[] args) throws Exception {
         Configuration conf = new Configuration();
         String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
         if (otherArgs.length != 2) {
           System.err.println("Usage: wordcount &lt;in&gt; &lt;out&gt;");
           System.exit(2);
         }

         FileSystem fstm = FileSystem.get(conf);
         Path outDir = new Path(otherArgs[1]);
         fstm.delete(outDir, true);

    conf.set("mapred.textoutputformat.separator", "\t"); //reduce输出时key value中间的分隔符
         Job job = new Job(conf, "HouseCountHz");
         job.setNumReduceTasks(2);
         job.setJarByClass(HouseCountHz.class);
         job.setMapperClass(HouseCountHzMapper.class);

         job.setMapOutputKeyClass(Text.class);
         job.setMapOutputValueClass(FloatWritable.class);

         // 设置reduce
         // 设置reduce的输出
         job.setReducerClass(HouseCountHzReducer.class);
         job.setOutputKeyClass(Text.class);
         job.setOutputValueClass(FloatWritable.class);
         //job.setNumReduceTasks(18);
         FileInputFormat.addInputPath(job, new Path(otherArgs[0]));
         FileOutputFormat.setOutputPath(job, new Path(otherArgs[1]));
         System.exit(job.waitForCompletion(true) ? 0 : 1);
       }
 }</pre>
</div>
<p><strong>第四个MR</strong></p>
<div>
<pre class="prettyprint linenums"> import java.io.IOException;
 import java.util.Iterator;

 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.FloatWritable;

 import org.apache.hadoop.io.LongWritable;

 import org.apache.hadoop.io.Text;
 import org.apache.hadoop.io.WritableComparable;
 import org.apache.hadoop.io.WritableComparator;

 import org.apache.hadoop.mapreduce.Job;
 import org.apache.hadoop.mapreduce.Mapper;
 import org.apache.hadoop.mapreduce.Partitioner;
 import org.apache.hadoop.mapreduce.Reducer;

 import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
 import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
 import org.apache.hadoop.util.GenericOptionsParser;

 /*
  * 输入数据:
  * 楼盘1 楼盘2 共同出现的次数
  *
  * 输出数据
  *  楼盘1 楼盘2,楼盘3,楼盘4 (按次数排序)
  */

 public class HouseRowToCol {

     public static class Partitioner1 extends Partitioner&lt;TextPairSecond, Text&gt; {
           @Override
           //分区
           public int getPartition(TextPairSecond key, Text value, int numParititon) {
                        return Math.abs((new Text(key.getFirst().toString()+key.getSecond().toString())).hashCode() * 127) % numParititon;

           }
     }
     //分组
           public static class Comp1 extends WritableComparator {
               public Comp1() {
                super(TextPairSecond.class, true);
               }
               @SuppressWarnings("unchecked")
               public int compare(WritableComparable a, WritableComparable b) {
                   TextPairSecond t1 = (TextPairSecond) a;
                   TextPairSecond t2 = (TextPairSecond) b;
                 return t1.getFirst().compareTo(t2.getFirst());

               }
             }

           //排序
           public static class KeyComp extends WritableComparator {
               public KeyComp() {
                super(TextPairSecond.class, true);
               }
               @SuppressWarnings("unchecked")
               public int compare(WritableComparable a, WritableComparable b) {
                   TextPairSecond t1 = (TextPairSecond) a;
                   TextPairSecond t2 = (TextPairSecond) b;
                int comp= t1.getFirst().compareTo(t2.getFirst());
                if (comp!=0)
                    return comp;
                return -t1.getSecond().compareTo(t2.getSecond());
               }
             }
       public static class HouseRowToColMapper
            extends Mapper&lt;LongWritable, Text, TextPairSecond, Text&gt;{

           Text houseid1=new Text();
           Text houseid2=new Text();
           FloatWritable weight=new FloatWritable();
         public void map(LongWritable key, Text value, Context context
                         ) throws IOException, InterruptedException {

          String s[]=value.toString().split("\t");

            weight.set(Float.parseFloat(s[2]));
            houseid1.set(s[0]);
            houseid2.set(s[1]);
          TextPairSecond tp=new TextPairSecond(houseid1,weight);
          context.write(tp, houseid2);
         }
       }

       public static class HouseRowToColReducer
            extends Reducer&lt;TextPairSecond,Text,Text,Text&gt; {

        Text valuev=new Text();
         public void reduce(TextPairSecond key, Iterable&lt;Text&gt; values,
                            Context context
                            ) throws IOException, InterruptedException {
             Text keyv=key.getFirst();
             Iterator&lt;Text&gt; it=values.iterator();
             StringBuilder sb=new StringBuilder(it.next().toString());
             while(it.hasNext())
             {
                 sb.append(","+it.next().toString());
             }
             valuev.set(sb.toString());
             context.write(keyv, valuev);

         }
       }

       public static void main(String[] args) throws Exception {
         Configuration conf = new Configuration();
         String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
         if (otherArgs.length != 2) {
           System.err.println("Usage: wordcount &lt;in&gt; &lt;out&gt;");
           System.exit(2);
         }

         FileSystem fstm = FileSystem.get(conf);
         Path outDir = new Path(otherArgs[1]);
         fstm.delete(outDir, true);

    conf.set("mapred.textoutputformat.separator", "\t"); //reduce输出时key value中间的分隔符
         Job job = new Job(conf, "HouseRowToCol");
         job.setNumReduceTasks(4);
         job.setJarByClass(HouseRowToCol.class);
         job.setMapperClass(HouseRowToColMapper.class);

         job.setMapOutputKeyClass(TextPairSecond.class);
         job.setMapOutputValueClass(Text.class);
         // 设置partition
         job.setPartitionerClass(Partitioner1.class);
         // 在分区之后按照指定的条件分组
         job.setGroupingComparatorClass(Comp1.class);
         job.setSortComparatorClass(KeyComp.class);
         // 设置reduce
         // 设置reduce的输出
         job.setReducerClass(HouseRowToColReducer.class);
         job.setOutputKeyClass(Text.class);
         job.setOutputValueClass(Text.class);
         //job.setNumReduceTasks(18);
         FileInputFormat.addInputPath(job, new Path(otherArgs[0]));
         FileOutputFormat.setOutputPath(job, new Path(otherArgs[1]));
         System.exit(job.waitForCompletion(true) ? 0 : 1);
       }
 }</pre>
</div>
<p><strong>来自：http://blog.csdn.net/u011750989/article/details/12004065</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39067n9d.html">fastjson-alibaba</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9ppn049.html">十一个行为模式之观察者模式&lpar;Observer Pattern&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd55o09.html">JAVA对MySQL数据库的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ddmeq.html">RandomAccessFile使用小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oy2vlq.html">javascript-binarySearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mr6p09.html">PostgreSQL除法保留小数</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ellmkq.html">sql语句与 数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1oged9.html">Linux - gcc和g&plus;&plus;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd25oxq.html">java 反射创建对象并传入参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0l778.html">20150225--ASP&period;NET基础（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oz2v39.html">如何实现CSS居中？&ndash;CSS居中常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljj6ze9.html">C语言功能 --C</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoerjnq.html">&lbrack;原创&rsqb;浅谈JAVA在ACM中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95072o68.html">spring boot 错误，求大神帮解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mlvgn8.html">强化学习 - Q-learning  Sarsa  和 DQN 的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1ey0q.html">用js写的时钟Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwxzr8.html">从Joda-Time反观Java语言利弊</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1row648.html">app v1界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppd1r79.html">C&num;（WPF和WinForm）在普通类中调用到主线程的方法，SynchronizationContext的用法。</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1l6ge9.html">【iOS XMPP】使用XMPPFramewok（一）：添加XMPPFramework（XCode 4&period;6&period;2）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2w6nwoq.html">centos 7下配置mysql&plus;php&lpar;ThinkPHP&rpar;&plus;nginx</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1lkjx8.html">&lbrack;&period;Net MVC&rsqb; 使用SQL Server数据库代替LocalDb</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmx05z9.html">文本框限制输入类型&amp;lt&semi;input&amp;gt&semi;的输入框</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x6rdn9.html">InstallShield Clone dialog</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1l7v39.html">html元素li移动动态效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x647n9.html">javascripct数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y6x70q.html">sencha touch mvc</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1lmnx9.html">cocos2dx伸缩式列表效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xn6468.html">iOS上绘制自然的签名-b</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok2xjx9.html">js 转化类似这样的时间&lpar; &sol;Date&lpar;1389060261000&rpar;&sol;&rpar;问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
